/*
Copyright 2024.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package v1alpha1

import (
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

// EDIT THIS FILE!  THIS IS SCAFFOLDING FOR YOU TO OWN!
// NOTE: json tags are required.  Any new fields you add must have json tags for the fields to be serialized.

// DiffSpec defines the desired state of Diff
type DiffSpec struct {
	AppSourceName string `json:"appSourceName"`
	TargetRef     string `json:"targetRef"`
}

// DiffStatus defines the observed state of Diff
type DiffStatus struct {
	DiffSecret string `json:"diffSecret"`
}

// +kubebuilder:object:root=true
// +kubebuilder:subresource:status

// Diff is the Schema for the diffs API
type Diff struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   DiffSpec   `json:"spec,omitempty"`
	Status DiffStatus `json:"status,omitempty"`
}

// +kubebuilder:object:root=true

// DiffList contains a list of Diff
type DiffList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []Diff `json:"items"`
}

func init() {
	SchemeBuilder.Register(&Diff{}, &DiffList{})
}
